<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_list.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">print_list.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="print__list_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2021 Martin B. Krauss.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Licensed under the MIT LICENSE.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// See the file &#39;LICENSE&#39; that should be distributed with this software or can</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// be found at &#39;https://gitlab.com/martin.b.krauss/cpp20-print&#39; for details.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CPP20PRINT_PRINT_LISTS_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CPP20PRINT_PRINT_LISTS_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__options_8h.html">print_options.h</a>&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__concepts_8h.html">print_concepts.h</a>&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">namespace </span>cpp20print::printing {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">   20</a></span>&#160;concept <a class="code" href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">PrintableListNoString</a> = </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        concepts::PrintableList&lt;T&gt; &amp;&amp;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        concepts::Printable&lt;T&gt; ==  <span class="keyword">false</span> &amp;&amp;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        concepts::UnicodeString&lt;T&gt; == <span class="keyword">false</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;}</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>cpp20print::printing::detail {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">// forward declarations </span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keywordtype">void</span> print_element(std::ostream&amp;, <span class="keyword">const</span> PrintOptions&amp;, <span class="keyword">const</span> T&amp;);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ablePair T&gt;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keywordtype">void</span> print_element(std::ostream&amp;, <span class="keyword">const</span> PrintOptions&amp;, <span class="keyword">const</span> T&amp;);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">template</span>&lt;Pr<span class="keywordtype">int</span>ableListNoString T&gt;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keywordtype">void</span> print_element(std::ostream&amp;, <span class="keyword">const</span> PrintOptions&amp;, <span class="keyword">const</span> T&amp;);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ablePair P&gt;</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="print__list_8h.html#a9e9ae4f30c9bde484e0c197b90e39e46">   42</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="print__list_8h.html#a9e9ae4f30c9bde484e0c197b90e39e46">print_pair</a> (</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">const</span> P&amp; pair,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        ) </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;{</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    out &lt;&lt; options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a850462ed203b590bd4679bd987364d73">pairStyle</a>.<a class="code" href="structcpp20print_1_1printing_1_1ListStyle.html#a55c457193f9a8730ea343e39084f992d">delimiters</a>.first;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, pair.first);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    out &lt;&lt; options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a850462ed203b590bd4679bd987364d73">pairStyle</a>.<a class="code" href="structcpp20print_1_1printing_1_1ListStyle.html#ad6abfeabd9d43b6bc40c801ee9f8c447">seperator</a>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, pair.second);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    out &lt;&lt; options.<a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a850462ed203b590bd4679bd987364d73">pairStyle</a>.<a class="code" href="structcpp20print_1_1printing_1_1ListStyle.html#a55c457193f9a8730ea343e39084f992d">delimiters</a>.second;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ableList L&gt; requires concepts::HasLastElement&lt;L&gt;</div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">   58</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a>(</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> L&amp; list, </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options = {}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        )</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;{</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; listStyle = options.listStyle;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    out &lt;&lt; listStyle.delimiters.first;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">auto</span> childOptions {options};</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordflow">if</span> (options.listStyle.subListStyle != <span class="keyword">nullptr</span>) {</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        childOptions.listStyle = *options.listStyle.subListStyle;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    }</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; end = *(--list.end());</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">size_t</span> count {0};</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; element: list) {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        ++count;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, element);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordflow">if</span> (&amp;element != &amp;end) {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            out &lt;&lt; listStyle.seperator;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            <span class="keywordflow">if</span> (    count == listStyle.maxElementsPrinted - 1 &amp;&amp; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                    !listStyle.expand</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                    ) </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                <span class="keywordflow">if</span> (list.size() &gt; listStyle.maxElementsPrinted) </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                    out &lt;&lt; <span class="stringliteral">&quot;...&quot;</span> &lt;&lt; listStyle.seperator;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;                <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, childOptions, end);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    }</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    out &lt;&lt; listStyle.delimiters.second;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;}</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ableList L&gt;</div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="print__list_8h.html#a3ba3a7765fb2dec731f3722c4cb6ee5b">  100</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a>(</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keyword">const</span> L&amp; list, </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp; options = {}</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        )</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;{</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; listStyle = options.listStyle;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    out &lt;&lt; listStyle.delimiters.first;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keyword">auto</span> childOptions {options};</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordflow">if</span> (options.listStyle.subListStyle != <span class="keyword">nullptr</span>) {</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        childOptions.listStyle = *options.listStyle.subListStyle;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    }</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordtype">size_t</span> count {0};</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; element: list) {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        ++count;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, childOptions, element);</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keywordflow">if</span> (count != list.size()) {</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            out &lt;&lt; listStyle.seperator;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="keywordflow">if</span> (    count == listStyle.maxElementsPrinted &amp;&amp;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;                    !listStyle.expand</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;                    ) </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                    out &lt;&lt; <span class="stringliteral">&quot;...&quot;</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        }</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    out &lt;&lt; listStyle.delimiters.second;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;}</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructcpp20print_1_1printing_1_1ListStyle_html_ad6abfeabd9d43b6bc40c801ee9f8c447"><div class="ttname"><a href="structcpp20print_1_1printing_1_1ListStyle.html#ad6abfeabd9d43b6bc40c801ee9f8c447">cpp20print::printing::ListStyle::seperator</a></div><div class="ttdeci">std::string seperator</div><div class="ttdoc">Defines the symbol that seperates list items.</div><div class="ttdef"><b>Definition:</b> print_options.h:28</div></div>
<div class="ttc" id="aprint__list_8h_html_a9e9ae4f30c9bde484e0c197b90e39e46"><div class="ttname"><a href="print__list_8h.html#a9e9ae4f30c9bde484e0c197b90e39e46">cpp20print::printing::detail::print_pair</a></div><div class="ttdeci">void print_pair(std::ostream &amp;out, const P &amp;pair, const PrintOptions &amp;options)</div><div class="ttdoc">Prints a pair.</div><div class="ttdef"><b>Definition:</b> print_list.h:42</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html">cpp20print::printing::PrintOptions</a></div><div class="ttdoc">Sets the options of the print() function.</div><div class="ttdef"><b>Definition:</b> print_options.h:42</div></div>
<div class="ttc" id="aprint__concepts_8h_html"><div class="ttname"><a href="print__concepts_8h.html">print_concepts.h</a></div></div>
<div class="ttc" id="aprint_8h_html_afe9466890a34c5498386a55281bf30a7"><div class="ttname"><a href="print_8h.html#afe9466890a34c5498386a55281bf30a7">cpp20print::printing::detail::print_element</a></div><div class="ttdeci">void print_element(std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</div><div class="ttdoc">Prints a single object. Default for objects that are not lists (&quot;atoms&quot;).</div><div class="ttdef"><b>Definition:</b> print.h:23</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1ListStyle_html_a55c457193f9a8730ea343e39084f992d"><div class="ttname"><a href="structcpp20print_1_1printing_1_1ListStyle.html#a55c457193f9a8730ea343e39084f992d">cpp20print::printing::ListStyle::delimiters</a></div><div class="ttdeci">std::pair&lt; std::string, std::string &gt; delimiters</div><div class="ttdoc">Defines the symbols that are printed at the beginning and end of the list.</div><div class="ttdef"><b>Definition:</b> print_options.h:25</div></div>
<div class="ttc" id="aprint__list_8h_html_aecd33a9a08711f90f308fc69f05aa827"><div class="ttname"><a href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">cpp20print::printing::detail::print_list</a></div><div class="ttdeci">requires concepts::HasLastElement&lt; L &gt; void print_list(std::ostream &amp;out, const L &amp;list, const PrintOptions &amp;options={})</div><div class="ttdoc">Prints an ordered list.</div><div class="ttdef"><b>Definition:</b> print_list.h:58</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_a850462ed203b590bd4679bd987364d73"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#a850462ed203b590bd4679bd987364d73">cpp20print::printing::PrintOptions::pairStyle</a></div><div class="ttdeci">ListStyle pairStyle</div><div class="ttdoc">Defines the formatting style for pairs (std::pair, map items, ...).</div><div class="ttdef"><b>Definition:</b> print_options.h:96</div></div>
<div class="ttc" id="aprint__list_8h_html_adc7f764bf8b8bbba1e7c57153ac51413"><div class="ttname"><a href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">cpp20print::printing::PrintableListNoString</a></div><div class="ttdeci">concept PrintableListNoString</div><div class="ttdoc">A list that is not a string or unicode string.</div><div class="ttdef"><b>Definition:</b> print_list.h:20</div></div>
<div class="ttc" id="aprint__options_8h_html"><div class="ttname"><a href="print__options_8h.html">print_options.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
